package AutoAnnotation;

import Index.IndexJDialog;
import gontogle.MainFrame;
import java.awt.*;
import java.awt.event.*;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.HashMap;
import java.util.Iterator;
import java.util.LinkedHashMap;
import java.util.LinkedList;
import java.util.Map.Entry;
import javax.swing.*;
import org.apache.lucene.index.IndexReader;
import org.apache.lucene.index.Term;
import org.apache.lucene.search.BooleanClause.Occur;
import org.apache.lucene.search.BooleanQuery;
import org.apache.lucene.search.Hits;
import org.apache.lucene.search.IndexSearcher;
import org.apache.lucene.search.Searcher;
import org.apache.lucene.search.TermQuery;

public class AutoAnnotatorResults {

    static String selectedSuggestion = null;
    static String searchFile = null;
    static int flagForIndexing = 0;
    //static JCheckBox checkBox;
    static public ArrayList<String> classesNames;

    public AutoAnnotatorResults() {
    }
//public static ArrayList<String>classesNames;

    private static void sugestResults(final String[] suggestions, final String[] suggestionNodes, final JDialog jdialog, final MainFrame currentWindow) {

        MainFrame.suggestCheckBoxPanel.removeAll();

        int maxLength = 65;
        for (int i = 0; i < suggestions.length; i++) {
            System.out.println(suggestions[i]);

            if (suggestions[i].length() > maxLength) {
                maxLength = suggestions[i].length();
            }
        }
        maxLength = maxLength - 65;
        //    MainFrame.suggestAnnotations.setPreferredSize(new Dimension(350,suggestions.length*40));
        if (suggestions.length > 10) {
            MainFrame.suggestAnnotations.setMinimumSize(new Dimension(540 + maxLength * 5, 200 + suggestions.length * 25));
            MainFrame.suggestAnnotations.setSize(new Dimension(540 + maxLength * 5, 200 + suggestions.length * 25));
            MainFrame.suggestAnnotations.setPreferredSize(new Dimension(540 + maxLength * 5, 200 + suggestions.length * 25));


        } else {
            MainFrame.suggestAnnotations.setMinimumSize(new Dimension(540 + maxLength * 5, 100 + suggestions.length * 40));
            MainFrame.suggestAnnotations.setSize(new Dimension(540 + maxLength * 5, 100 + suggestions.length * 40));
            MainFrame.suggestAnnotations.setPreferredSize(new Dimension(540 + maxLength * 5, 100 + suggestions.length * 40));

        }
        MainFrame.suggestAnnotations.setLocationRelativeTo(jdialog);
        final ArrayList<JCheckBox> checkBoxList = new ArrayList<JCheckBox>();
        //Create the radio buttons.
        for (int i = 1; i <= suggestions.length; i++) {
            JCheckBox newButton = new JCheckBox(suggestions[i - 1]); // To suggestions[i-1] einai to onoma pou tha emfanizei to button dipla.
            newButton.setActionCommand(String.valueOf(i));
            //newButton.addActionListener(classSelected);
            checkBoxList.add(newButton);
            //   group.add(newButton);
            MainFrame.suggestCheckBoxPanel.add(newButton); //Pros8etei to new button sto panel
        }


        MainFrame.indexCheckBox.setVisible(false);
        //Kataskeuh kai pros8hkh tou checkBox
        if ((flagForIndexing == 1) && (MainFrame.aFlag != 1)) { //An to eggrafo den einai indexed kai an den prokeitai gia tmhmatiko annotation, ftiakxe checkbox.
   
//            MainFrame.indexCheckBox.setVisible(true);
            flagForIndexing = 0;
        }

        MainFrame.annotSuggestButton.addActionListener(new ActionListener() { //ActionListener interface contains only the actionPerformed() method.

            public void actionPerformed(ActionEvent e) {
                //if (!ignoreButton.isSelected()) {
                if (checkBoxList.isEmpty()) {
                    return;
                }

                classesNames.clear();
                for (int i = 0; i < checkBoxList.size(); i++) {
                    if (checkBoxList.get(i).isSelected()) {
                        String cls = checkBoxList.get(i).getText().substring(0, checkBoxList.get(i).getText().indexOf(" "));
                        //String cls = suggestionNodes[Integer.parseInt(radioList.get(i).getActionCommand()) - 1];
                        classesNames.add(cls);
                        System.out.println(cls);
                    }
                }
                if (!AutoAnnotatorResults.classesNames.isEmpty()) {//epilektikan classes gia annotation
                    if (MainFrame.aFlag == 1) {   //text annot
                        currentWindow.textManualAnnotation(classesNames);
                    } else {  //doc annot
                        currentWindow.docManualAnnotation(classesNames);
                    }
                }

              
                if (MainFrame.indexCheckBox.isSelected()) {
                    new IndexJDialog(searchFile, true);//.setVisible(true);
                    MainFrame.indexCheckBox.setSelected(false);
                }

                checkBoxList.clear();

                //nik: edo to ekana sxolio
                //   currentWindow.deselectAllAnnotateTextArea(); //Apoepilegai tyxon epilegmeno keimeno tmhmatikou annotation
                MainFrame.autoAnnotationFlag = 0; // Afou path8ei to OK, dinetai ksana h dynatothta na path8ei to autoAnnotButton.
                jdialog.dispose(); // Otan path8ei to OK, kleinei to para8uro.
            }
        });

        //  add(okButton);
        MainFrame.ignoreSuggestButton.addActionListener(new ActionListener() { //ActionListener interface contains only the actionPerformed() method.

            public void actionPerformed(ActionEvent e) {
                jdialog.dispose();
                selectedSuggestion = "0"; // Kleisimo tou para8yrou isodynamei me epilogh tou "ignore suggestion".

                MainFrame.autoAnnotationFlag = 0; //G
                checkBoxList.clear();
            }
        });

        jdialog.addWindowListener(new WindowAdapter() {

            public void windowClosing(WindowEvent e) {
                selectedSuggestion = "0"; // Kleisimo tou para8yrou isodynamei me epilogh tou "ignore suggestion".
            
                MainFrame.autoAnnotationFlag = 0; //Gia na mporei na ksanapath8ei to "autoAnnotbutton".
                checkBoxList.clear();
            }
        });
    
    }

    /**Kalei thn  AutomaticAnnotator.annotate(text, searchFile), opou
     * text= to pros xarakthrismo keimeno kai searcheFile to eggrafo,
     * kai ths epistrefontai oi protinomenoi komboi ontologiwn.*/
    public static void annotateText(String text, String searchFile1, MainFrame currentWindow) {
        searchFile = searchFile1;
        classesNames = new ArrayList<String>();
        LinkedHashMap<String, Float> annotatorSuggestions = AutomaticAnnotator.annotate(text, searchFile);
        String[] classNamesAndScores = new String[annotatorSuggestions.size()]; //Proteinomena onomata klasewn & to posostiaio score tous.
        String[] suggestedClasses = new String[annotatorSuggestions.size()]; //Proteinomenes klaseis
        int i = 0;
        for (Entry<String, Float> entry : annotatorSuggestions.entrySet()) {
            if (entry != null) {
                classNamesAndScores[i] = entry.getKey() + "  " + entry.getValue() + " %";//px. ths morfhs OLAP 23.5%
                suggestedClasses[i] = entry.getKey();
                i++;
            }
        }
        checkIfIndexed(searchFile1); //Elegxos an to eggrafo exei ginei indexed.
        getChoice(formatStringArray(classNamesAndScores), suggestedClasses, currentWindow);
    }

    /**Dhmiourgei para8uro me tis dynates epiloges gia to xrhsth.*/
    private static void getChoice(final String[] suggestions1, final String[] suggestionNodes, final MainFrame currentWindow) {
        //Schedule a job for the event-dispatching thread:
        //creating and showing this application's GUI.

        if (suggestions1.length == 0) { //An den yparxoun suggestions h' to eggrafo den periexei keimeno.
            JOptionPane.showMessageDialog(null, "              There are no suggestions.", "Auto Annotation Results", JOptionPane.PLAIN_MESSAGE);
            MainFrame.autoAnnotationFlag = 0; //Gia na mporei na ksanapath8ei to "autoAnnotbutton".
        } else {

            sugestResults(suggestions1, suggestionNodes, MainFrame.suggestAnnotations, currentWindow);

            
            MainFrame.suggestAnnotations.setVisible(true);
            MainFrame.indexCheckBox.setSelected(false);
            MainFrame.suggestAnnotations.setLocationRelativeTo(null);
        }
    }

    /**Diamorfwnei ton pinaka apo string pou dexetai wste na emfanizei ta apotelesmata kata
     * f8inousa seira score. An yparxoyn apotelesmata me to idio score, ta emfanizei alfabhtika*/
    private static String[] formatStringArray(String[] initialArray) {
        String[] formatArray = initialArray;
        HashMap<Float, LinkedList<String>> tsou = new HashMap<Float, LinkedList<String>>(); //{float score, linkedlist{klaseis pou exoun auto to score}}

        //Afairw to " %"
        for (int i = 0; i < formatArray.length; i++) {
            formatArray[i] = formatArray[i].substring(0, formatArray[i].length() - 2);
            //System.out.println(formatArray[i]);
            float value = Float.parseFloat(formatArray[i].substring(formatArray[i].lastIndexOf(" ") + 1, formatArray[i].length())); //pairnei to score
            formatArray[i] = formatArray[i].substring(0, formatArray[i].lastIndexOf(" ")); //Twra h 8esh formatArray[i] periexei mono thn klash
            if (!tsou.containsKey(value)) {
                LinkedList<String> list = new LinkedList<String>();
                list.add(formatArray[i]);
                tsou.put(value, list);
            } else {
                LinkedList<String> l = tsou.get(value);
                l.add(formatArray[i]);
                tsou.put(value, l);
            }
        }
        //taxhnomw ta periexomena ka8e listas alfabhtika.
        for (Entry<Float, LinkedList<String>> entry : tsou.entrySet()) {
            LinkedList<String> l = entry.getValue();
            Collections.sort(l);
            tsou.put(entry.getKey(), l);
        }

        Float[] sortedValues = new Float[tsou.size()]; //Bazw ola ta score gia na ta taxonomhsw.
        int j = 0;
        for (Entry<Float, LinkedList<String>> entry : tsou.entrySet()) {
            sortedValues[j] = entry.getKey();
            j++;
        }
        Arrays.sort(sortedValues); //taxinomhsh kata auxousa seira

        LinkedHashMap<Float, LinkedList<String>> finalMap = new LinkedHashMap<Float, LinkedList<String>>();//Periexei ta taxinomhmena score me tis  taxinomhmenes listes tous.
        for (int i = sortedValues.length - 1; i >= 0; i--) {
            LinkedList<String> list = tsou.get(sortedValues[i]);
            finalMap.put(sortedValues[i], list);
        }

        //Kataskeuazw ton teliko pinaka string pou 8a epistrafei.
        String[] finalArray = new String[initialArray.length];
        int i = 0;
        for (Entry<Float, LinkedList<String>> entry : finalMap.entrySet()) {
            LinkedList<String> l = entry.getValue();
            Iterator<String> it = l.iterator();
            while (it.hasNext()) {
                finalArray[i] = it.next() + " " + entry.getKey() + " %";
                i++;
            }
        }
        return finalArray;
    }

    /**Elegxos an to eggrafo exei ginei indexed*/
    private static void checkIfIndexed(String searchFile) {

        try {

            String index=MainFrame.indexDir;

            //Etoimazomai na ftiaksw to query sto Lucene
            IndexReader reader = IndexReader.open(index);
            Searcher searcher = new IndexSearcher(reader);

            TermQuery ttt = new TermQuery(new Term("path", searchFile));
            //System.out.println(searchFile.getName());
            BooleanQuery testquery = new BooleanQuery();
            testquery.add(ttt, Occur.SHOULD);
            Hits hits = searcher.search(testquery);
            
            if (hits.length() == 0) {
                //System.out.println("DEN EINAI INDEXED TO"+searchFile.getName());
                flagForIndexing = 1;
            } else {
                //System.out.println("EINAI INDEXED TO"+searchFile.getName());
            }
        } catch (FileNotFoundException ex) {
            ex.printStackTrace();
        } catch (IOException ex) {
            ex.printStackTrace();
        }
    }

}
