/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package CmdLine;

import Ontology.ProtegeServer;
import edu.stanford.smi.protege.model.KnowledgeBase;
import edu.stanford.smi.protege.model.Project;
import edu.stanford.smi.protegex.owl.model.OWLModel;
import edu.stanford.smi.protegex.owl.model.OWLNamedClass;
import edu.stanford.smi.protegex.owl.ui.cls.HierarchyManager;
import java.util.Collection;
import java.util.Iterator;

/**
 *
 * @author Cyan
 */
public class ProtegeInterface {

    private ProtegeServer protegeServer = null;
    //public static String serverIP = "147.102.12.175";
    public static String serverIP = "127.0.0.1";
    public static String serverUser = "Guest";
    public static String serverPass = "guest";

    public void initProtege() {
        //serverIP = "192.168.1.33";
        serverIP = "127.0.0.1";
        protegeServer = new ProtegeServer();
//        protegeServer.connect("localhost", "Guest", "guest");
        protegeServer.connect(serverIP, serverUser, serverPass);
        //TODO fix na vgeni mnm
        if (protegeServer.getSession() == null) {
            //TODO jdialog
            System.out.println("ERROR: "+" Can not connect to Protege Server."+ "No Connection");
        }

    }

    public void closeProtegeConnection() {
        protegeServer.disconect();
    }

    public void getOntologyList() {
        Collection<String> projNames = protegeServer.getAvailableProjectNames();
        if (projNames != null) {
            System.out.println("Ontology list:");
            for (int i=0;i<projNames.size();i++)
                System.out.println(projNames.toArray()[i]);
        } else {
            System.out.println("Ontology list empty");
            //loadProjDialogButton.setEnabled(false);

        }
    }

    public void listOntologyConcepts(String ontologyName) {
            Project ontologyProject;
            OWLModel owlModel;
        
            String selectedProjName = ontologyName;

            if (protegeServer.getOpenedProjects().containsKey(selectedProjName) == true) {
                ontologyProject = (Project) protegeServer.getOpenedProjects().get(selectedProjName);
                //System.out.println("1111");
            } else {
                ontologyProject = protegeServer.openProject(selectedProjName);
                //System.out.println("22222");
            }

//            int f = showOntology(ontologyProject);
//            if (f == -1) {
//                this.setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
//                c.setCursor(new Cursor(Cursor.TEXT_CURSOR));
//                return;
//            }
            //--------------------------

        KnowledgeBase kb = ontologyProject.getKnowledgeBase();
        try {
            owlModel = (OWLModel) kb;
        } catch (Exception e) {
            System.out.println("Opening Ontology Error: "+" Ontology loading failed, This is not an OWL ontology! ");
            return;
        }
        // ProtegeUI.getProjectView(proj);
        // OWLNamedClass pickClass = owlModel.getOWLNamedClass("owl:Thing");

        // com.hp.hpl.jena.ontology.OntModel  m= owlModel.getOntModel();

        Iterator<OWLNamedClass> itr = owlModel.listOWLNamedClasses();
        while(itr.hasNext()) {
            OWLNamedClass element = itr.next();
            System.out.println(element.getName());

        }
        /*
        HierarchyManager hierarchyManager = null;
        AssertedClassesPanel listPanel = new AssertedClassesPanel(ontologyProject, hierarchyManager);
//listPanel..getClsesTree();
        ontojInternalFrame.setVisible(true);
        ontojInternalFrame.setTitle(selectedProjName);

        //System.out.println("project nameeeeee..." + ontologyProject.getProjectName());

        classJtree = listPanel.getClsesTree();
        classJtree.setEditable(false);
        classJtree.setRootVisible(false);
        classJtree.updateUI();
        // System.out.println("        classJtree.setEditable(false)");

        classJtree.addMouseListener(jTreemouseListener);
        //eeeeeeedooooooooooooooo
//ontoJtreePane.setLayout(new BorderLayout());
//ontoJtreePane.add(listPanel.getClsesTree());
        ontoJtreePane.setViewportView(classJtree);

        //jTree1=listPanel.getClsesTree();
//java.awt.Container cont = ontojInternalFrame.getContentPane();
        //cont.setLayout(new BorderLayout());
        //cont.add(BorderLayout.CENTER, listPanel.getClsesTree());

        Collection errors = new ArrayList();

        Ontology.chekOntology(owlModel);

        if (docjInternalFrame.isVisible()) {
            //  annotationsjInternalFrame.setVisible(true);
            showAnnotations();
        }
        return 0;
*/
    }

    public OWLModel getOntology(String ontologyName) {
            Project ontologyProject;
            OWLModel owlModel;

            String selectedProjName = ontologyName;

            if (protegeServer.getOpenedProjects().containsKey(selectedProjName) == true) {
                ontologyProject = (Project) protegeServer.getOpenedProjects().get(selectedProjName);
                //System.out.println("1111");
            } else {
                ontologyProject = protegeServer.openProject(selectedProjName);
                //System.out.println("22222");
            }


        KnowledgeBase kb = ontologyProject.getKnowledgeBase();
        try {
            owlModel = (OWLModel) kb;
        } catch (Exception e) {
            System.out.println("Opening Ontology Error: "+" Ontology loading failed, This is not an OWL ontology! ");
            return null;
        }

        return owlModel;
    }
}
