/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package Multivalent;

import gontogle.MainFrame;
import java.util.StringTokenizer;
import multivalent.*;

/**
 *
 * @author Nikos
 */
public class PDFDoc {

    public static long totalWords;
    public static String text;

    public static void init(String filePath) {

        text = getString(filePath);
        totalWords = getTotalWords();

    }

    private static String getString(String filePath) {
        String tmp;
        System.out.println("stin getText " + filePath);
        tmp = PDFTextParser.pdftoText(filePath);
        return tmp;
    }

    //first call getString 
    private static long getTotalWords() {

        long tmpTotalWords = 0;


        StringTokenizer st = new StringTokenizer(text);
        tmpTotalWords = st.countTokens();

        return tmpTotalWords;
    }

    public static void ZoomIn(Browser br) {

        float z = br.getCurDocument().getMediaAdaptor().getZoom();
        z = (float) (z + 0.1);



        br.getCurDocument().getMediaAdaptor().setZoom(z);


        String genre = br.getCurDocument().getAttr(Document.ATTR_GENRE);
        if (genre != null) {
            Multivalent.getInstance().putPreference(genre + "-zoom", Float.toString(z));
        }

//        br.eventq(br.getCurDocument().getAttr(Document.ATTR_PAGE) == null ? Document.MSG_RELOAD : Multipage.MSG_RELOADPAGE, null);
        br.getCurDocument().removeAllChildren();

        br.getCurDocument().getLayer(Layer.SCRATCH).clear();
        br.getCurDocument().getLayers().buildBeforeAfter(br.getCurDocument());
        br.setCurDocument(br.getCurDocument());	// regen UI

    }

    public static void ZoomOut(Browser br) {
        float z = br.getCurDocument().getMediaAdaptor().getZoom();
        z = (float) (z - 0.1);

        br.getCurDocument().getMediaAdaptor().setZoom(z);


        String genre = br.getCurDocument().getAttr(Document.ATTR_GENRE);
        if (genre != null) {
            Multivalent.getInstance().putPreference(genre + "-zoom", Float.toString(z));
        }

//        br.eventq(br.getCurDocument().getAttr(Document.ATTR_PAGE) == null ? Document.MSG_RELOAD : Multipage.MSG_RELOADPAGE, null);
        br.getCurDocument().removeAllChildren();

        br.getCurDocument().getLayer(Layer.SCRATCH).clear();
        br.getCurDocument().getLayers().buildBeforeAfter(br.getCurDocument());
        br.setCurDocument(br.getCurDocument());	// regen UI

    }

    public static void ResetZoom(Browser br) {
        float z = (float) 1.0;
//        z=(float) (z - 0.1);

        br.getCurDocument().getMediaAdaptor().setZoom(z);


        String genre = br.getCurDocument().getAttr(Document.ATTR_GENRE);
        if (genre != null) {
            Multivalent.getInstance().putPreference(genre + "-zoom", Float.toString(z));
        }

//        br.eventq(br.getCurDocument().getAttr(Document.ATTR_PAGE) == null ? Document.MSG_RELOAD : Multipage.MSG_RELOADPAGE, null);

        br.getCurDocument().removeAllChildren();

        br.getCurDocument().getLayer(Layer.SCRATCH).clear();
        br.getCurDocument().getLayers().buildBeforeAfter(br.getCurDocument());
        br.setCurDocument(br.getCurDocument());	// regen UI
    }

    public static void goToNextPage(Browser br) {
        String pageNum = br.getCurDocument().getAttr(Document.ATTR_PAGE);
        Integer pNum = Integer.parseInt(pageNum);

        if (pNum < Integer.parseInt(br.getCurDocument().getAttr(Document.ATTR_PAGECOUNT))) {

            pNum++;
                        MainFrame.curPage.setText(pNum.toString());


            br.getCurDocument().putAttr(Document.ATTR_PAGE, pNum.toString());
            br.getCurDocument().removeAllChildren();

            br.getCurDocument().getLayer(Layer.SCRATCH).clear();
            br.getCurDocument().getLayers().buildBeforeAfter(br.getCurDocument());
            br.setCurDocument(br.getCurDocument());	// regen UI

        }
    }

    public static void goToPrevPage(Browser br) {
        String pageNum = br.getCurDocument().getAttr(Document.ATTR_PAGE);

        
        Integer pNum = Integer.parseInt(pageNum);
        if (pNum > 1) {
            pNum--;
            MainFrame.curPage.setText(pNum.toString());

            br.getCurDocument().putAttr(Document.ATTR_PAGE, pNum.toString());
            br.getCurDocument().removeAllChildren();

            br.getCurDocument().getLayer(Layer.SCRATCH).clear();
            br.getCurDocument().getLayers().buildBeforeAfter(br.getCurDocument());
            br.setCurDocument(br.getCurDocument());	// regen UI
        }
    }

    public static void goToPage(Browser br, long pageNum) {


        String pageNumStr = Integer.toString((int) pageNum);
            MainFrame.curPage.setText(pageNumStr);

        br.getCurDocument().putAttr(Document.ATTR_PAGE, pageNumStr);
        br.getCurDocument().removeAllChildren();

        br.getCurDocument().getLayer(Layer.SCRATCH).clear();
        br.getCurDocument().getLayers().buildBeforeAfter(br.getCurDocument());
        br.setCurDocument(br.getCurDocument());	// regen UI

    }
}
