/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package Ontology;

import edu.stanford.smi.protegex.owl.model.OWLDatatypeProperty;
import edu.stanford.smi.protegex.owl.model.OWLIndividual;
import edu.stanford.smi.protegex.owl.model.OWLModel;
import edu.stanford.smi.protegex.owl.model.OWLNamedClass;
import edu.stanford.smi.protegex.owl.model.RDFIndividual;
import edu.stanford.smi.protegex.owl.model.RDFProperty;
import edu.stanford.smi.protegex.owl.model.RDFResource;
//import edu.stanford.smi.protegex.owl.model.RDFSClass;
import edu.stanford.smi.protegex.owl.model.RDFSNamedClass;
import edu.stanford.smi.protegex.owl.model.impl.DefaultRDFIndividual;
import java.util.ArrayList;
import java.util.Collection;
import java.util.HashSet;
import java.util.Iterator;
import javax.swing.JOptionPane;

/**
 *
 * @author Nikos
 */
public class Ontology1 {

    public final static String posPropName = "gONTOgle__position";
    public final static String countPropName = "gONTOgle__count";
    public final static String URLPropName = "gONTOgle__fileURL";
    public final static String percPropName = "gONTOgle__percent";
    public final static String pagePropName = "gONTOgle__page";
    public final static String textSummaryPropName = "gONTOgle__text";
    public final static String linePropName = "gONTOgle__line";

    public static void chekOntology(OWLModel owlModel) {
        ArrayList<RDFSNamedClass> domainsClassesForOffProp = new ArrayList<RDFSNamedClass>();
        ArrayList<RDFSNamedClass> domainsClassesForCountProp = new ArrayList<RDFSNamedClass>();
        ArrayList<RDFSNamedClass> domainsClassesForURLProp = new ArrayList<RDFSNamedClass>();
        ArrayList<RDFSNamedClass> domainsClassesForPercentProp = new ArrayList<RDFSNamedClass>();
        ArrayList<RDFSNamedClass> domainsClassesForLineProp = new ArrayList<RDFSNamedClass>();
        ArrayList<RDFSNamedClass> domainsClassesForTextProp = new ArrayList<RDFSNamedClass>();
        ArrayList<RDFSNamedClass> domainsClassesForPageProp = new ArrayList<RDFSNamedClass>();

        ArrayList<RDFSNamedClass> cls;
        Collection pr;
        String prName;
        boolean offsetFound = false;
        boolean URLFound = false;
        boolean percentFound = false;
        boolean countFound = false;
        boolean pageFound = false;
        boolean textFound = false;

        boolean lineFound = false;

        int i, j;
        cls = (ArrayList<RDFSNamedClass>) owlModel.getUserDefinedRDFSNamedClasses();
        for (i = 0; i < cls.size(); i++) {
            offsetFound = false;
            URLFound = false;
            countFound = false;
            percentFound = false;
            pageFound = false;
            textFound = false;
            lineFound = false;

            pr = cls.get(i).getPossibleRDFProperties();
            Iterator iter = pr.iterator();
            while (iter.hasNext()) {
                prName = ((RDFProperty) iter.next()).getLocalName();
                if (lineFound == true && percentFound == true && countFound == true && offsetFound == true && URLFound == true) {
                    break;
                }
                if (prName.equalsIgnoreCase(posPropName)) {
                    offsetFound = true;
                }
                if (prName.equalsIgnoreCase(percPropName)) {
                    percentFound = true;
                }
                if (prName.equalsIgnoreCase(countPropName)) {
                    countFound = true;
                }
                if (prName.equalsIgnoreCase(URLPropName)) {
                    URLFound = true;
                }
                if (prName.equalsIgnoreCase(linePropName)) {
                    lineFound = true;
                }
                if (prName.equalsIgnoreCase(textSummaryPropName)) {
                    textFound = true;
                }
                if (prName.equalsIgnoreCase(pagePropName)) {
                    pageFound = true;
                }
            }
            if (URLFound == false) {
                domainsClassesForURLProp.add(cls.get(i));

            }
            if (percentFound == false) {
                domainsClassesForPercentProp.add(cls.get(i));

            }
            if (countFound == false) {
                domainsClassesForCountProp.add(cls.get(i));

            }
            if (offsetFound == false) {
                domainsClassesForOffProp.add(cls.get(i));
            }
            if (lineFound == false) {
                domainsClassesForLineProp.add(cls.get(i));
            }
            if (pageFound == false) {
                domainsClassesForPageProp.add(cls.get(i));
            }

            if (textFound == false) {
                domainsClassesForTextProp.add(cls.get(i));
            }


        }
        addProperties(owlModel, domainsClassesForOffProp, domainsClassesForCountProp, domainsClassesForURLProp, domainsClassesForPercentProp, domainsClassesForLineProp, domainsClassesForTextProp, domainsClassesForPageProp);
    }

    private static void addProperties(OWLModel owlModel, ArrayList<RDFSNamedClass> domainsClassesForOffProp, ArrayList<RDFSNamedClass> domainsClassesForCountProp, ArrayList<RDFSNamedClass> domainsClassesForURLProp, ArrayList<RDFSNamedClass> domainsClassesForpercentProp, ArrayList<RDFSNamedClass> domainsClassesForlineProp, ArrayList<RDFSNamedClass> domainsClassesForTextProp, ArrayList<RDFSNamedClass> domainsClassesForPageProp) {


        //create properties if not existed
        OWLDatatypeProperty urlPr = owlModel.getOWLDatatypeProperty(URLPropName);
        if (urlPr == null) {
            urlPr = owlModel.createOWLDatatypeProperty(URLPropName);
            urlPr.setRange(owlModel.getXSDstring());

        }

        OWLDatatypeProperty offPr = owlModel.getOWLDatatypeProperty(posPropName);
        if (offPr == null) {
            offPr = owlModel.createOWLDatatypeProperty(posPropName);
            //offPr.setRange(owlModel.getXSDlong());
            offPr.setRange(owlModel.getXSDint());
        }

        OWLDatatypeProperty countPr = owlModel.getOWLDatatypeProperty(countPropName);
        if (countPr == null) {
            countPr = owlModel.createOWLDatatypeProperty(countPropName);
            // countPr.setRange(owlModel.getXSDlong());
            countPr.setRange(owlModel.getXSDint());
        }


        OWLDatatypeProperty percPr = owlModel.getOWLDatatypeProperty(percPropName);
        if (percPr == null) {
            percPr = owlModel.createOWLDatatypeProperty(percPropName);
            // countPr.setRange(owlModel.getXSDlong());
            percPr.setRange(owlModel.getXSDfloat());
        }
        OWLDatatypeProperty linePr = owlModel.getOWLDatatypeProperty(linePropName);
        if (linePr == null) {
            linePr = owlModel.createOWLDatatypeProperty(linePropName);
            // countPr.setRange(owlModel.getXSDlong());
            linePr.setRange(owlModel.getXSDint());
        }

        OWLDatatypeProperty pagePr = owlModel.getOWLDatatypeProperty(pagePropName);
        if (pagePr == null) {
            pagePr = owlModel.createOWLDatatypeProperty(pagePropName);
            // countPr.setRange(owlModel.getXSDlong());
            pagePr.setRange(owlModel.getXSDint());
        }

        OWLDatatypeProperty textPr = owlModel.getOWLDatatypeProperty(textSummaryPropName);
        if (textPr == null) {
            textPr = owlModel.createOWLDatatypeProperty(textSummaryPropName);
            // countPr.setRange(owlModel.getXSDlong());
            textPr.setRange(owlModel.getXSDstring());
        }



        if (!domainsClassesForOffProp.isEmpty()) {
            offPr.setDomains(domainsClassesForOffProp);
        }
        if (!domainsClassesForCountProp.isEmpty()) {
            countPr.setDomains(domainsClassesForCountProp);
        }
        if (!domainsClassesForURLProp.isEmpty()) {
            urlPr.setDomains(domainsClassesForURLProp);
        }
        if (!domainsClassesForpercentProp.isEmpty()) {
            percPr.setDomains(domainsClassesForpercentProp);
        }

        if (!domainsClassesForlineProp.isEmpty()) {
            linePr.setDomains(domainsClassesForlineProp);
        }

        if (!domainsClassesForPageProp.isEmpty()) {
            pagePr.setDomains(domainsClassesForPageProp);
        }

        if (!domainsClassesForTextProp.isEmpty()) {
            textPr.setDomains(domainsClassesForTextProp);
        }
    }

    public static String createInstance(OWLModel owlModel, String docURL, ArrayList<String> classesNames, long pos, long count, float perc, long line, long page, String text) {
        OWLIndividual instance;

        String instanceName;

        if (classesNames.isEmpty()) {
            return null;
        }


        String newDocURL = docURL.replace("\\", ""); //for valid rdf:id names
        newDocURL = newDocURL.replace(" ", "_"); //for valid rdf:id names

        if (pos == -1) {
            instanceName = newDocURL + "__";
        }
        else {
            instanceName = newDocURL + "__" + pos + "_" + count + "__";
        }
        // System.out.println("instance name " + instanceName);


        for (int i = 0; i < classesNames.size(); i++) {
            instanceName = instanceName + classesNames.get(i);
            if (i != classesNames.size() - 1) {
                instanceName = instanceName + "_";
            }
        }
        System.out.println("instance name " + instanceName);

        OWLNamedClass selclass = owlModel.getOWLNamedClass(owlModel.getDefaultOWLOntology().getURI()+classesNames.get(0));
        if (selclass == null) {//check ontology URI with #
            selclass = owlModel.getOWLNamedClass(owlModel.getDefaultOWLOntology().getURI()+"#"+classesNames.get(0));
        }
        if (selclass == null) {//in case of owlthing
            selclass = owlModel.getOWLNamedClass(owlModel.getDefaultOWLOntology().getURI()+classesNames.get(1));
            if (selclass == null) {//check ontology URI with #
                selclass = owlModel.getOWLNamedClass(owlModel.getDefaultOWLOntology().getURI()+"#"+classesNames.get(1));
            }
        }

        try {
            instance = selclass.createOWLIndividual(instanceName);
        } catch (Exception e) {
            JOptionPane.showMessageDialog(null, "The selected text is already annotated.", "Duplicate Annotation", JOptionPane.ERROR_MESSAGE);
            return null;
        }
        for (int i = 1; i < classesNames.size(); i++) {
            selclass = owlModel.getOWLNamedClass(owlModel.getDefaultOWLOntology().getURI()+classesNames.get(i));
            if (selclass == null) {//check ontology URI with #
                selclass = owlModel.getOWLNamedClass(owlModel.getDefaultOWLOntology().getURI()+"#"+classesNames.get(i));
            }
            if (selclass != null) { //null for the owlthing case
                instance.addRDFType(selclass);
            }

        }

        OWLDatatypeProperty posProp = owlModel.getOWLDatatypeProperty(posPropName);
        OWLDatatypeProperty countProp = owlModel.getOWLDatatypeProperty(countPropName);
        OWLDatatypeProperty URLProp = owlModel.getOWLDatatypeProperty(URLPropName);
        OWLDatatypeProperty percProp = owlModel.getOWLDatatypeProperty(percPropName);
        OWLDatatypeProperty lineProp = owlModel.getOWLDatatypeProperty(linePropName);
        OWLDatatypeProperty pageProp = owlModel.getOWLDatatypeProperty(pagePropName);
        OWLDatatypeProperty textProp = owlModel.getOWLDatatypeProperty(textSummaryPropName);

        instance.setPropertyValue(URLProp, docURL);
        instance.setPropertyValue(posProp, (int) pos);
        instance.setPropertyValue(countProp, (int) count);
        instance.setPropertyValue(percProp, (float) perc);
        instance.setPropertyValue(lineProp, (int) line);
        instance.setPropertyValue(pageProp, (int) page);
        instance.setPropertyValue(textProp, text);

        return instanceName;
    }

    public static void addClassesToInstance(OWLModel owlModel, String instanceName, ArrayList<String> classesNames) {
        for (int i = 0; i < classesNames.size(); i++) {
            OWLNamedClass selClass = owlModel.getOWLNamedClass(owlModel.getDefaultOWLOntology().getURI()+classesNames.get(i));
            if (selClass == null) {//check ontology URI with #
                selClass = owlModel.getOWLNamedClass(owlModel.getDefaultOWLOntology().getURI()+"#"+classesNames.get(i));
            }
            owlModel.getOWLIndividual(instanceName).addRDFType(selClass);
        }

    }

    public static void deleteClassFromInstance(OWLModel owlModel, String instanceName, String ClassName) {
        OWLNamedClass selClass = owlModel.getOWLNamedClass(owlModel.getDefaultOWLOntology().getURI()+ClassName);
        if (selClass == null) {//check ontology URI with #
            selClass = owlModel.getOWLNamedClass(owlModel.getDefaultOWLOntology().getURI()+"#"+ClassName);
        }
        owlModel.getOWLIndividual(instanceName).removeRDFType(selClass);
    //owlModel.getInstance(ClassName)
    //     .getInstance("s").removeDirectType("r");
    }

    public static void deleteInstance(OWLModel owlModel, String instanceName) {
//System.out.println(instanceName);
//          System.out.println(owlModel.getInstance(instanceName));
//System.out.println(owlModel.getOWLIndividual(instanceName));
//System.out.println(owlModel.getRDFIndividual(instanceName));
        owlModel.deleteInstance(owlModel.getInstance(instanceName));
    }

    //return the annotations of a doc
    public static ArrayList<AnnotationObj> getInsancesForDoc(OWLModel owlModel, String docURL) {
        ArrayList<AnnotationObj> annotations = new ArrayList<AnnotationObj>();
        //OWLIndividual inst;
        //RDFIndividual inst;
        OWLIndividual inst;
        //ArrayList<OWLIndividual> instances;
        ArrayList<RDFIndividual> instances;
        HashSet<OWLIndividual> instances2;
        HashSet<OWLIndividual> instances3;
        //instances = (ArrayList<OWLIndividual>) owlModel.getUserDefinedRDFIndividuals(false);
        instances = (ArrayList<RDFIndividual>) owlModel.getUserDefinedRDFIndividuals(false);
        instances2 = (HashSet<OWLIndividual>) owlModel.getOWLIndividuals();
        instances3 = (HashSet<OWLIndividual>) owlModel.getOWLIndividuals(false);
        System.out.println("instances count: "+instances.size());
        System.out.println("instances2 count: "+instances2.size());
        System.out.println("Looking for: "+docURL);

//  System.out.println("arithmos instances.."+instances.size());

        OWLDatatypeProperty URLProp = owlModel.getOWLDatatypeProperty(URLPropName);
        OWLDatatypeProperty countProp = owlModel.getOWLDatatypeProperty(countPropName);
        OWLDatatypeProperty posProp = owlModel.getOWLDatatypeProperty(posPropName);
        OWLDatatypeProperty percProp = owlModel.getOWLDatatypeProperty(percPropName);
        OWLDatatypeProperty lineProp = owlModel.getOWLDatatypeProperty(linePropName);
        OWLDatatypeProperty pageProp = owlModel.getOWLDatatypeProperty(pagePropName);

        OWLDatatypeProperty textProp = owlModel.getOWLDatatypeProperty(textSummaryPropName);

        Iterator<OWLIndividual> it = instances2.iterator();
        while(it.hasNext()) {
            OWLIndividual element = it.next();
            System.out.print("interator2: "+element.toString());
            System.out.println("-- property: "+element.getPropertyValue(URLProp));

        }

        for (int i = 0; i < instances.size(); i++) {
            //inst = instances.get(i); //(OWLIndividual)
            //inst = owlModel.getOWLIndividual(instances.get(i).getName()); //(OWLIndividual)
            //System.out.println(instances.get(i).getName());
            inst = owlModel.getOWLIndividual(instances.get(i).getName()); //(OWLIndividual)
            if (inst==null) continue;
            //getOWLIndividuals(true)

            /*
            RDFProperty URLProp = owlModel.getRDFProperty(URLPropName);
            RDFProperty countProp = owlModel.getRDFProperty(countPropName);
            RDFProperty posProp = owlModel.getRDFProperty(posPropName);
            RDFProperty percProp = owlModel.getRDFProperty(percPropName);
            RDFProperty lineProp = owlModel.getRDFProperty(linePropName);
            RDFProperty pageProp = owlModel.getRDFProperty(pagePropName);

            RDFProperty textProp = owlModel.getRDFProperty(textSummaryPropName);
            */

            //OWLDatatypeProperty URLProp2 = owlModel.getOWLDatatypeProperty(URLPropName);
            //OWLDatatypeProperty URLProp3 = owlModel.getOWLDatatypeProperty("http://gi2mo.org/LaptopTaxonomy/ns#test_data");

            //System.out.println("Sets0: URLProp - "+URLProp.toString());
            //System.out.println("owl ind: "+instances2.toArray()[i].getPropertyValue(URLProp2));
//            if (owlModel.getOWLIndividual(inst.getName())!=null)
//            {
//            System.out.println("owl ind666: "+owlModel.getOWLIndividual(inst.getName()).getPropertyValue(URLProp2));
//            System.out.println("owl ind666_2: "+owlModel.getOWLIndividual(inst.getName()).getPropertyValue(URLProp3));
//            }
//            System.out.println("docURL: "+inst.getName());
//            System.out.println("owl ind: "+inst.getOWLModel().getOWLIndividuals().size());
//            System.out.println("inst - "+inst.toString());
//            System.out.println("inst - "+inst.getPropertyValue(URLProp));
            System.out.println("Sets: URLProp - "+inst.getPropertyValue(URLProp) + " posProp - "+ inst.getPropertyValue(posProp) + " countProp - "+ inst.getPropertyValue(countProp) +" precProp - "+ inst.getPropertyValue(percProp) + " lineProp - "+ inst.getPropertyValue(lineProp) );
// System.out.println("Onoma instance : "+inst.getName());
            if (inst.getPropertyValue(URLProp) == null || inst.getPropertyValue(posProp) == null || inst.getPropertyValue(countProp) == null || inst.getPropertyValue(percProp) == null || inst.getPropertyValue(lineProp) == null) {
                continue;
            }
            String url = (String) inst.getPropertyValue(URLProp);
            Integer pos = (Integer) inst.getPropertyValue(posProp);
            Integer count = (Integer) inst.getPropertyValue(countProp);
            float perc = (Float) inst.getPropertyValue(percProp);
            Integer line = (Integer) inst.getPropertyValue(lineProp);
            Integer page = (Integer) inst.getPropertyValue(pageProp);
            String text = (String) inst.getPropertyValue(textProp);
            //System.out.println("url: "+url);
            //System.out.println("Sets2: url - "+url + " pos - "+ pos + " count - "+ count +" perc - "+ perc + " line - "+ line + " page - "+ page + " text - "+ text);
            if (url == null || count == null || pos == null || line == null || text == null || page == null || !url.equalsIgnoreCase(docURL)) {
                //    System.out.println("dn vrike property");
                continue;

            }
            AnnotationObj annot = new AnnotationObj();
            annot.count = count;
            annot.docURL = url;
            annot.pos = pos;
            annot.percent = perc;
            annot.line = line;
            annot.instanceName = inst.getName();
            annot.page = page;
            annot.annotatedText = text;

//         System.out.println("instance local name "+   inst.getLocalName());
//         System.out.println("instance name "+   inst.getName());
            //annot.annotationsNumber++;

            // System.out.println("URl  "+url);
            // System.out.println("ppos  "+pos);
            //  System.out.println("count  "+count);

            //  ArrayList<RDFSClass> rdfTypes= (ArrayList<RDFSClass>) inst.getRDFTypes();

            Collection types = inst.getRDFTypes();

            Iterator iterator = types.iterator();
            while (iterator.hasNext()) {
                RDFResource resource = (RDFResource) iterator.next();
                if (resource instanceof OWLNamedClass) {
                    annot.classes.add(resource.getLocalName());
                //  System.out.println("Type  "+  resource.getLocalName());
                }
            } // while


            annotations.add(annot);

        }


        return annotations;
    }

//xrisimopoihte apo tin related search
    //epistrefi ola ta instance twn clasewn me tis opoies ine anot ena doc
    public static ArrayList<OWLIndividual> getAnnotClassesAllInsancesForDocSearch(OWLModel owlModel, String docURL) {

        ArrayList<OWLIndividual> AllInstances = new ArrayList<OWLIndividual>();


        ArrayList<OWLIndividual> instances = new ArrayList<OWLIndividual>();
        ArrayList<OWLIndividual> docInstances = new ArrayList<OWLIndividual>();

        OWLIndividual inst;

        //  ArrayList<OWLIndividual> instances;
        instances = (ArrayList<OWLIndividual>) owlModel.getUserDefinedRDFIndividuals(false);

//  System.out.println("arithmos instances.."+instances.size());

        for (int i = 0; i < instances.size(); i++) {
            inst = instances.get(i);

            OWLDatatypeProperty URLProp = owlModel.getOWLDatatypeProperty(URLPropName);
            OWLDatatypeProperty countProp = owlModel.getOWLDatatypeProperty(countPropName);
            OWLDatatypeProperty posProp = owlModel.getOWLDatatypeProperty(posPropName);
            OWLDatatypeProperty percProp = owlModel.getOWLDatatypeProperty(percPropName);
            OWLDatatypeProperty lineProp = owlModel.getOWLDatatypeProperty(linePropName);
            OWLDatatypeProperty textProp = owlModel.getOWLDatatypeProperty(textSummaryPropName);
            OWLDatatypeProperty pageProp = owlModel.getOWLDatatypeProperty(pagePropName);

            if (inst.getPropertyValue(URLProp) == null || inst.getPropertyValue(posProp) == null || inst.getPropertyValue(countProp) == null || inst.getPropertyValue(percProp) == null || inst.getPropertyValue(lineProp) == null) {
                continue;
            }
// System.out.println("Onoma instance : "+inst.getName());
            String url = (String) inst.getPropertyValue(URLProp);
            Integer pos = (Integer) inst.getPropertyValue(posProp);
            Integer count = (Integer) inst.getPropertyValue(countProp);
            float perc = (Float) inst.getPropertyValue(percProp);
            Integer line = (Integer) inst.getPropertyValue(lineProp);
            Integer page = (Integer) inst.getPropertyValue(pageProp);
            String text = (String) inst.getPropertyValue(textProp);

            if (url == null || count == null || pos == null || line == null || text == null || page == null || !url.equalsIgnoreCase(docURL)) {
                //    System.out.println("dn vrike property");
                continue;
            }
            else {

                docInstances.add(inst);
            }


        }

        ArrayList<OWLNamedClass> AnnotClasses = new ArrayList<OWLNamedClass>();

        for (int i = 0; i < docInstances.size(); i++) {
            inst = docInstances.get(i);
            ArrayList<OWLNamedClass> classes = new ArrayList<OWLNamedClass>();


            Collection types = inst.getRDFTypes();

            //   Collection types = individual.getRDFTypes();
            Iterator iterator = types.iterator();
            //ArrayList<String> classes = new ArrayList<String>();
            while (iterator.hasNext()) {
                RDFResource cl = (RDFResource) iterator.next();
                if (cl instanceof OWLNamedClass) {
                    classes.add((OWLNamedClass) cl);
                }
            } // while



            for (int cl = 0; cl < classes.size(); cl++) {
                //checkkkkkkkkkkkkkkkkkkkkkkkkk
                if (!AnnotClasses.contains(classes.get(cl))) {
                    AnnotClasses.add(classes.get(cl));
                }
            }
        }

        for (int cl = 0; cl < AnnotClasses.size(); cl++) {

            AllInstances.addAll(AnnotClasses.get(cl).getInstances(false));
        }

        return AllInstances;

    }

    //epistrefei ta instances twn subclassewn tis class cl
    public static ArrayList<OWLIndividual> getSubClassesInstances(OWLNamedClass cl) {
        ArrayList<OWLIndividual> instances = new ArrayList<OWLIndividual>();

        Collection subClasses;// = new ArrayList<OWLNamedClass>();

        subClasses = cl.getSubclasses(false);

        Iterator iterator = subClasses.iterator();

        while (iterator.hasNext()) {
            RDFResource cls = (RDFResource) iterator.next();
            if (cls instanceof OWLNamedClass) {
                instances.addAll(((OWLNamedClass) cls).getInstances(false));
            }
        }

        return instances;
    }

    //epistrefei ta instances twn superclassewn tis class cl
    public static ArrayList<OWLIndividual> getSuperClassesInstances(OWLNamedClass cl) {
        ArrayList<OWLIndividual> instances = new ArrayList<OWLIndividual>();

        Collection superClasses;// = new ArrayList<OWLNamedClass>();

        superClasses = cl.getSuperclasses(false);

        Iterator iterator = superClasses.iterator();

        while (iterator.hasNext()) {
            RDFResource cls = (RDFResource) iterator.next();
            if (cls instanceof OWLNamedClass) {
                instances.addAll(((OWLNamedClass) cls).getInstances(false));
            }
        }

        return instances;
    }
}
