/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package OpenOffice;

import com.sun.star.beans.PropertyState;
import com.sun.star.beans.PropertyValue;
import com.sun.star.beans.PropertyVetoException;
import com.sun.star.beans.UnknownPropertyException;
import com.sun.star.beans.XPropertySet;
import com.sun.star.bridge.XUnoUrlResolver;
import com.sun.star.comp.beans.HasConnectionException;
import com.sun.star.comp.beans.NoConnectionException;
import com.sun.star.comp.beans.OOoBean;
import com.sun.star.comp.beans.SystemWindowException;
import com.sun.star.frame.XController;
import com.sun.star.frame.XDesktop;
import com.sun.star.lang.IllegalArgumentException;
import com.sun.star.lang.WrappedTargetException;
import com.sun.star.lang.XMultiComponentFactory;
import com.sun.star.text.XTextDocument;
import com.sun.star.uno.UnoRuntime;
import com.sun.star.uno.XComponentContext;
import com.sun.star.util.CloseVetoException;
import java.awt.Container;
import java.io.IOException;
import java.net.MalformedURLException;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.JOptionPane;

/**
 *
 * @author Nikos
 */
public class OOfficeDoc {

    private static String _interProcCommunicationString = "pipe,name=Bruno_Office";
    private static OfficeBean aViewer = null;
    private static OOoBean aBean = null;
    public static String ooPath;
    public static short Zoom;
    //private static com.sun.star.frame.XController xController;

    public static int openDoc(OfficeBean aViewer, OOoBean aBean, javax.swing.JInternalFrame docjInternalFrame, String docURL) {
        //OOoBean aBean = null;
        if (aBean != null) {
            aBean.clear();
        }
        if (aViewer == null) {
            aViewer = new OfficeBean();
            aViewer.initialize();
            aViewer.start();
            aBean = aViewer.getABean();


            //  xController=aViewer.getxController();
            aBean.setAllBarsVisible(false);
            Container c = (Container) docjInternalFrame.getContentPane();
            c.removeAll();
            c.repaint();
            docjInternalFrame.repaint();
//                docjInternalFrame.removeAll();

            docjInternalFrame.add(aViewer);
            docjInternalFrame.updateUI();
        }

        try {
            //[-------------------------------------------------dokimi ayto
            aBean.setAllBarsVisible(false);
            Container c = (Container) docjInternalFrame.getContentPane();
            c.removeAll();
            c.repaint();
            docjInternalFrame.repaint();
//                docjInternalFrame.removeAll();

            docjInternalFrame.add(aViewer);
            docjInternalFrame.updateUI();
            //[-------------------------------------------------

            docjInternalFrame.setVisible(true);
            docjInternalFrame.setSize(570, 770);
            // launch the OOo server, use pipe for inter-process communication
            String commandLine = "\"" + ooPath + "/program/soffice" + "\" -invisible -nologo -accept=" + _interProcCommunicationString + ";urp;StarOffice.ServiceManager";
            Runtime.getRuntime().exec(commandLine);
            try {
                // suspend the current thread to let OO server start
                Thread.sleep(500);
            } catch (InterruptedException ex) {
                Logger.getLogger(OOfficeDoc.class.getName()).log(Level.SEVERE, null, ex);
            }
            try {
                if (aBean.getOOoConnection() == null) {
                    System.out.println("edo mpike sto coonect tu openoffice");
                    // initialize the OOo bean connection
                    aBean.startOOoConnection("uno:" + _interProcCommunicationString + ";urp;StarOffice.ServiceManager");
                }
            } catch (MalformedURLException ex) {
                Logger.getLogger(OOfficeDoc.class.getName()).log(Level.SEVERE, null, ex);
            } catch (HasConnectionException ex) {
                Logger.getLogger(OOfficeDoc.class.getName()).log(Level.SEVERE, null, ex);
            }

            PropertyValue[] loadProperties = new PropertyValue[1];
            loadProperties[0] = new PropertyValue("ReadOnly", 0, new Boolean(true), PropertyState.DIRECT_VALUE);
            //aBean.startOOoConnection("file:///" + docURL)l

            aBean.loadFromURL("file:///" + docURL, loadProperties);

            docjInternalFrame.setTitle(docURL);
        } catch (Exception ex) {
                //cursor
//        this.setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
////        c.setCursor(new Cursor(Cursor.TEXT_CURSOR))
            docjInternalFrame.setVisible(false);
            JOptionPane.showMessageDialog(null, " An error occurs while opening the file. Please try again. ", "Opening File Error", JOptionPane.ERROR_MESSAGE);
            if (aBean != null) {
                aBean.clear();
            }
            return -1;
        }

//        } catch (NoConnectionException ex) {        ///TOSEE //TODO
//            System.out.println("NoConnectionException");
//            return;
//        //Logger.getLogger(OOfficeDoc.class.getName()).log(Level.SEVERE, null, ex);
//        } catch (IOException ex) {
//            System.out.println("IOException");
//            Logger.getLogger(OOfficeDoc.class.getName()).log(Level.SEVERE, null, ex);
//        } catch (IllegalArgumentException ex) {
//            Logger.getLogger(OOfficeDoc.class.getName()).log(Level.SEVERE, null, ex);
//        } catch (CloseVetoException ex) {
//            Logger.getLogger(OOfficeDoc.class.getName()).log(Level.SEVERE, null, ex);
//        }
        try {
            aBean.aquireSystemWindow();
        } catch (SystemWindowException ex) {
            Logger.getLogger(OOfficeDoc.class.getName()).log(Level.SEVERE, null, ex);
        } catch (NoConnectionException ex) {
            Logger.getLogger(OOfficeDoc.class.getName()).log(Level.SEVERE, null, ex);
        }

        resetZoom(aBean);
        OOfficeDoc.Zoom = 100;
        docjInternalFrame.updateUI();
        OOfficeDoc.aBean = aBean;
        OOfficeDoc.aViewer = aViewer;
    //return aBean;
        return 0;
    }

    public static void zoomOut(OOoBean aBean) {
        com.sun.star.frame.XModel xModel = null;
        try {
            xModel = (com.sun.star.frame.XModel) UnoRuntime.queryInterface(
                    com.sun.star.frame.XModel.class, aBean.getDocument());
        } catch (NoConnectionException ex) {
            Logger.getLogger(OOfficeDoc.class.getName()).log(Level.SEVERE, null, ex);
        }

        com.sun.star.view.XViewSettingsSupplier xViewSettings =
                (com.sun.star.view.XViewSettingsSupplier) UnoRuntime.queryInterface(
                com.sun.star.view.XViewSettingsSupplier.class, xModel.getCurrentController());

        short zoom = 0;
        try {
            zoom = (Short) xViewSettings.getViewSettings().getPropertyValue("ZoomValue");
        } catch (UnknownPropertyException ex) {
            Logger.getLogger(OOfficeDoc.class.getName()).log(Level.SEVERE, null, ex);
        } catch (WrappedTargetException ex) {
            Logger.getLogger(OOfficeDoc.class.getName()).log(Level.SEVERE, null, ex);
        }

        zoom = (short) (zoom - 10);
        OOfficeDoc.Zoom = zoom;
        try {
            xViewSettings.getViewSettings().setPropertyValue("ZoomValue", zoom);
        //  docjInternalFrame.updateUI();
        } catch (UnknownPropertyException ex) {
            Logger.getLogger(OOfficeDoc.class.getName()).log(Level.SEVERE, null, ex);
        } catch (PropertyVetoException ex) {
            Logger.getLogger(OOfficeDoc.class.getName()).log(Level.SEVERE, null, ex);
        } catch (IllegalArgumentException ex) {
            Logger.getLogger(OOfficeDoc.class.getName()).log(Level.SEVERE, null, ex);
        } catch (WrappedTargetException ex) {
            Logger.getLogger(OOfficeDoc.class.getName()).log(Level.SEVERE, null, ex);
        }
    //  docjInternalFrame.updateUI();


    }

    public static void zoomIn(OOoBean aBean) {
        com.sun.star.frame.XModel xModel = null;
        try {
            xModel = (com.sun.star.frame.XModel) UnoRuntime.queryInterface(
                    com.sun.star.frame.XModel.class, aBean.getDocument());
        } catch (NoConnectionException ex) {
            Logger.getLogger(OOfficeDoc.class.getName()).log(Level.SEVERE, null, ex);
        }

        com.sun.star.view.XViewSettingsSupplier xViewSettings =
                (com.sun.star.view.XViewSettingsSupplier) UnoRuntime.queryInterface(
                com.sun.star.view.XViewSettingsSupplier.class, xModel.getCurrentController());
        try {
            short zoom = (Short) xViewSettings.getViewSettings().getPropertyValue("ZoomValue");

            zoom = (short) (zoom + 10);
            OOfficeDoc.Zoom = zoom;
            xViewSettings.getViewSettings().setPropertyValue("ZoomValue", zoom);
        //docjInternalFrame.updateUI();

        } catch (UnknownPropertyException ex) {
            Logger.getLogger(OOfficeDoc.class.getName()).log(Level.SEVERE, null, ex);
        } catch (PropertyVetoException ex) {
            Logger.getLogger(OOfficeDoc.class.getName()).log(Level.SEVERE, null, ex);
        } catch (IllegalArgumentException ex) {
            Logger.getLogger(OOfficeDoc.class.getName()).log(Level.SEVERE, null, ex);
        } catch (WrappedTargetException ex) {
            Logger.getLogger(OOfficeDoc.class.getName()).log(Level.SEVERE, null, ex);
        }
    }

    public static void resetZoom(OOoBean aBean) {
        com.sun.star.frame.XModel xModel = null;
        try {
            xModel = (com.sun.star.frame.XModel) UnoRuntime.queryInterface(
                    com.sun.star.frame.XModel.class, aBean.getDocument());
        } catch (NoConnectionException ex) {
            Logger.getLogger(OOfficeDoc.class.getName()).log(Level.SEVERE, null, ex);
        }
        com.sun.star.view.XViewSettingsSupplier xViewSettings =
                (com.sun.star.view.XViewSettingsSupplier) UnoRuntime.queryInterface(
                com.sun.star.view.XViewSettingsSupplier.class, xModel.getCurrentController());
        try {

            xViewSettings.getViewSettings().setPropertyValue("ZoomValue", new Short("100"));
            OOfficeDoc.Zoom = 100;

        } catch (UnknownPropertyException ex) {
            Logger.getLogger(OOfficeDoc.class.getName()).log(Level.SEVERE, null, ex);
        } catch (PropertyVetoException ex) {
            Logger.getLogger(OOfficeDoc.class.getName()).log(Level.SEVERE, null, ex);
        } catch (IllegalArgumentException ex) {
            Logger.getLogger(OOfficeDoc.class.getName()).log(Level.SEVERE, null, ex);
        } catch (WrappedTargetException ex) {
            Logger.getLogger(OOfficeDoc.class.getName()).log(Level.SEVERE, null, ex);
        }
    }


    /*
     * Stop connection then terminate the server process
     */
    public static boolean terminateRemoteDesktop(OOoBean aBean) throws java.lang.Exception {
        String unoUrl = null;
        unoUrl = "uno:" + _interProcCommunicationString + ";urp;StarOffice.ServiceManager";
        // disconnect the OO bean
        aBean.stopOOoConnection();

        // open another connection to the server, in order to call terminate it.
        // use of OOoBean.getOOoDesktop ().terminate () doesn't work so we have to do like this actually
        // in fact, OOoBean doesn't support termination of desktop (a bug of OOoBean)
        XComponentContext xRemoteContext = null;

        // create a local context then create a XUnoUrlResolver
        XComponentContext xLocalContext = com.sun.star.comp.helper.Bootstrap.createInitialComponentContext(null);
        XMultiComponentFactory xLocalServiceManager = xLocalContext.getServiceManager();
        Object urlResolver = xLocalServiceManager.createInstanceWithContext("com.sun.star.bridge.UnoUrlResolver", xLocalContext);
        XUnoUrlResolver xUnoUrlResolver = (XUnoUrlResolver) UnoRuntime.queryInterface(XUnoUrlResolver.class, urlResolver);

        // use XUnoUrlResolver to create the remote default context
        Object initialObject = xUnoUrlResolver.resolve(unoUrl);
        XPropertySet xPropertySet = (XPropertySet) UnoRuntime.queryInterface(XPropertySet.class, initialObject);
        Object context = xPropertySet.getPropertyValue("DefaultContext");
        xRemoteContext = (XComponentContext) UnoRuntime.queryInterface(XComponentContext.class, context);

        // get the remote desktop and call terminate () on it to terminate OOo process
        Object desk = xRemoteContext.getServiceManager().createInstanceWithContext("com.sun.star.frame.Desktop", xRemoteContext);
        XDesktop xDesk = (XDesktop) UnoRuntime.queryInterface(XDesktop.class, desk);

        return xDesk.terminate();
    }

    /**
     * @return the aViewer
     */
    public static OfficeBean getAViewer() {
        return aViewer;
    }
//     public XController getxController(){
//                 return xController;
//
//     }

    /**
     * @return the aBean
     */
    public static OOoBean getABean() {
        return aBean;
    }
}