/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package Multivalent;

import Ontology.AnnotationObj;
import OpenOffice.TextSelection;
import gontogle.MainFrame;
import java.awt.Color;
import java.util.ArrayList;
import javax.swing.JOptionPane;
import multivalent.*;
import multivalent.std.span.BackgroundSpan;


/**
 *
 * @author Nikos
 */
public class PDFText {

    public static String text;   //summary
    public static long start;
    public static long end;
    public static long wordsCount;

    public static void drawSelection(Browser br, Integer col) {
        Color color = new Color(col);
        BackgroundSpan ss1 = (BackgroundSpan) Behavior.getInstance("highlight", "HighlightSpan", null, br.getRoot().getLayer(Layer.SYSTEM));
        ss1.setColor(color);
        ss1.repaint();


        ss1.moveq(br.getSelectionSpan());

        br.getSelectionSpan().moveq(null);

        br.repaint();


    }

    public static void drawPage(Browser br, ArrayList<AnnotationObj> annotations) {

        if(annotations==null||annotations.isEmpty()){
            return;
        }

        int pNum;
        String pageNum = br.getCurDocument().getAttr(Document.ATTR_PAGE);
//      System.out.println("page num....."+pageNum);
      if(pageNum==null){
//           System.out.println("page num.....ine NULL");
        pNum = 1;
      }else{
        pNum = Integer.parseInt(pageNum);
      }
// System.out.println("page num.. INT..."+pNum);
        


        AnnotationObj annot = new AnnotationObj();
        long pos;
        long count;
        String selectedText;
        Integer color;
        for (int i = 0; i < annotations.size(); i++) {
            annot = annotations.get(i);

            if (annot.page != pNum) {
                continue;
            }

            count = annot.count;
            pos = annot.pos;
            color = annot.color;
            if (pos != -1) {
//                selectedText = drawText(pos, count, color);
//                annotations.get(i).annotatedText = selectedText;
                drawText(br, pos, count, color);
            }
            else {
//                annotations.get(i).annotatedText = "Whole DocumenCt";
            }
        }

//        return annotations;



    }

    public static void unDrawPage(Browser br, ArrayList<AnnotationObj> annotations) {
if(annotations==null||annotations.isEmpty()){
            return;
        }
//        String pageNum = br.getCurDocument().getAttr(Document.ATTR_PAGE);
//        int pNum = Integer.parseInt(pageNum);
int pNum;
        String pageNum = br.getCurDocument().getAttr(Document.ATTR_PAGE);
//      System.out.println("page num...page num......."+pageNum);
      if(pageNum==null){
        pNum =1;
      }else{
        pNum = Integer.parseInt(pageNum);
      }
// System.out.println("page num.. INT..."+pNum);

        AnnotationObj annot = new AnnotationObj();
        long pos;
        long count;
        for (int i = 0; i < annotations.size(); i++) {
            annot = annotations.get(i);

            if (annot.page != pNum) {
                continue;
            }

            count = annot.count;
            pos = annot.pos;

            if (pos != -1) {
//                selectedText = drawText(pos, count, color);
//                annotations.get(i).annotatedText = selectedText;
                unDrawText(br, pos, count);
            }
            else {
//                annotations.get(i).annotatedText = "Whole DocumenCt";
            }
        }

//        return annotations;



    }

    public static void drawText(Browser br, long start, long end, Integer col) {

        Color color = new Color(col);
        BackgroundSpan ss1 = (BackgroundSpan) Behavior.getInstance("highlight", "HighlightSpan", null, br.getRoot().getLayer(Layer.SYSTEM));
        ss1.setColor(color);
        ss1.repaint();

        int s = 0;
        Leaf startNode = br.getRoot().getFirstLeaf();
        for (s = 0; s < start; s++) {
//            System.out.println(startNode);
            startNode = startNode.getNextLeaf();
        }
 Leaf tmpNode;
        Leaf endNode = br.getRoot().getFirstLeaf();
        for (s = 0; s <= end; s++) {
            tmpNode=endNode.getNextLeaf();
            if(tmpNode==null){//for the case of last node 
                break;
            }
            endNode = endNode.getNextLeaf();
        }
        ss1.moveq(startNode, 0, endNode, 0);
        ss1.repaint();

        br.repaint();

    }

    public static void unDrawText(Browser br, long start, long end) {

        BackgroundSpan ss1 = (BackgroundSpan) Behavior.getInstance("highlight", "HighlightSpan", null, br.getRoot().getLayer(Layer.SYSTEM));
        ss1.setColor(Color.white);
        ss1.repaint();

        int s = 0;
        Leaf startNode = br.getRoot().getFirstLeaf();
        for (s = 0; s < start; s++) {
            startNode = startNode.getNextLeaf();
        }

        Leaf endNode = br.getRoot().getFirstLeaf();
        for (s = 0; s <= end; s++) {
            endNode = endNode.getNextLeaf();
        }
        ss1.moveq(startNode, 0, endNode, 0);

    }

    public static void caclulateSelectedPosition(Browser br) {
         if (!br.getSelectionSpan().isSet()) {//no text selected
                    JOptionPane.showMessageDialog(null, "No Text Selected", "Warning", JOptionPane.WARNING_MESSAGE);
                    return;
                }

        int s = 0;
        for (Node n = br.getRoot().getFirstLeaf(); n != br.getSelectionSpan().getStart().leaf; n = n.getNextLeaf()) {
            s++;
        }

        int e = 0;
        for (Node n = br.getRoot().getFirstLeaf(); n != br.getSelectionSpan().getEnd().leaf; n = n.getNextLeaf()) {
            e++;
        }

        start = s;
        end = e;
        text = "";
        wordsCount = 1;
        for (Node n = br.getSelectionSpan().getStart().leaf; n != br.getSelectionSpan().getEnd().leaf; n = n.getNextLeaf()) {
            text = text + " " + n.toString();
            wordsCount++;
        }
        text +=" "+ br.getSelectionSpan().getEnd().leaf;

         MainFrame.textForIndexing +=" "+text;

        text = TextSelection.textSummary(text);

//    br.getSelectionSpan().g
    }

    public static String getSelectedText(Browser br) {
        String txt = "";
        if(br.getSelectionSpan().isSet()){
        for (Node n = br.getSelectionSpan().getStart().leaf; n != br.getSelectionSpan().getEnd().leaf; n = n.getNextLeaf()) {
            txt = txt + " " + n.toString();
//            wordsCount++;
        }}
        return txt;

    }

    public static void moveToNode(Browser br, long pos) {
        Leaf node = br.getRoot().getFirstLeaf();

        for (long s = 0; s <= pos; s++) {
            node = node.getNextLeaf();
        }
        node.scrollTo();

    }
}
